/**
 * @file  L3Ax_demo.c
 * @brief LCD_IOTvvO
 *
 * {\tgEFA̒쌠͍쐬ł()kldqL̂ƂA
 * ()kldq́Aȉ (1)`(3) ̏𖞂ꍇɌA
 * {\tgEFAi{\tgEFAς̂܂ށBȉj
 * gpEEρEĔzziȉApƌĂԁj邱Ƃ𖳏ŋB
 *
 * (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́AL̒
 *	   \A̗pÂ܂܂̌`Ń\[XR[hɊ܂܂
 *	   邱ƁB
 * (2) {\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ֎~
 *	   ƂBGȂǂ֏ЉE^̏ꍇ()kldqɘA肢܂B
 * (3) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *	   A()kldq͈؂̐ӔC𕉂Ȃ̂ƂB
 *
 * Copyright (C) Hokuto denshi Co,Ltd. 2011
 *
 * e
 *	 C֐ɂďݒ肵\B
 *
 * ύX
 *	 2011/06/10 VK쐬
 */

/*----------------------------------------------------------------------
	CN[h
----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
	萔`
----------------------------------------------------------------------*/
#define LCR0	(*(volatile unsigned char *)0x0200)		//LCD䃌WX^
#define OCD 	(*(volatile unsigned char *)0x000C)		//U~oWX^
#define CM0 	(*(volatile unsigned char *)0x0006)		//VXeNbN䃌WX^0
#define CM1	(*(volatile unsigned char *)0x0007)		//VXeNbN䃌WX^1
#define FRA0	(*(volatile unsigned char *)0x0023)		//I`bvIV[^䃌WX^0
#define FRA2 	(*(volatile unsigned char *)0x0025)		//I`bvIV[^䃌WX^2
#define LSE0	(*(volatile unsigned char *)0x0206)		//LCD|[gIWX^0
#define LSE1	(*(volatile unsigned char *)0x0207)		//LCD|[gIWX^1
#define LSE2	(*(volatile unsigned char *)0x0208)		//LCD|[gIWX^2
#define LSE3	(*(volatile unsigned char *)0x0209)		//LCD|[gIWX^3
#define LSE4	(*(volatile unsigned char *)0x020a)		//LCD|[gIWX^4
#define LSE5	(*(volatile unsigned char *)0x020b)		//LCD|[gIWX^5
#define LSE6	(*(volatile unsigned char *)0x020c)		//LCD|[gIWX^6
#define LSE7	(*(volatile unsigned char *)0x020d)		//LCD|[gIWX^7
#define LCR0	(*(volatile unsigned char *)0x0200)		//LCD䃌WX^
#define LCR1	(*(volatile unsigned char *)0x0201)		//LCDoCAX䃌WX^
#define LCR2	(*(volatile unsigned char *)0x0202)		//LCD\䃌WX^
#define LCR3	(*(volatile unsigned char *)0x0203)		//LCDNbN䃌WX^
#define PRCR 	(*(volatile unsigned char *)0x000A)		//veNgWX^
#define P10	(*(volatile unsigned char *)0x00F4)		//|[gP10WX^
#define PD10 	(*(volatile unsigned char *)0x00F6)		//|[gP10WX^
#define P11	(*(volatile unsigned char *)0x00F5)		//|[gP10WX^
#define PD11 	(*(volatile unsigned char *)0x00F7)		//|[gP10WX^
#define P13	(*(volatile unsigned char *)0x00F9)		//|[gP13WX^
#define PD13 	(*(volatile unsigned char *)0x00FB)		//|[gP13WX^

/* 擾镶 */
#define CHAR_DATA_NUM	14

/* ڽ偨̏ */
#define CHAR_POG_0		0x022F
#define CHAR_POG_1		0x022B
#define CHAR_POG_2		0x0227
#define CHAR_POG_3		0x0223
#define CHAR_POG_4		0x021F
#define CHAR_POG_5		0x021B
#define CHAR_POG_6		0x0217
#define CHAR_POG_7		0x0213

/* ڽ̏ */
#define CHAR_POG_8		0x0230
#define CHAR_POG_9		0x0234
#define CHAR_POG_10		0x0238
#define CHAR_POG_11		0x023C
#define CHAR_POG_12		0x0240
#define CHAR_POG_13		0x0244

#define B0	0x01
#define B1	0x02
#define B2	0x04
#define B3	0x08
#define B4	0x10
#define B5	0x20
#define B6	0x40
#define B7	0x80

/* EFCgp}N */
#define CPU_CLOCK		( 20 * 1000000 )			// 20MHziI`bvIV[^gpj
#define SECOND			CPU_CLOCK
#define MILLI_SEC		( SECOND / 1000 )

/*----------------------------------------------------------------------
	vg^Cv錾
----------------------------------------------------------------------*/
static void LcdInit( void );
static void LcdDispOne( unsigned char num , char data );
static void LcdDispMulti( char *data );
static unsigned short LcdGetCurAddr( unsigned char num );
static unsigned short LcdGetNextAddr( unsigned short CurAddr, unsigned short CurAddrBackup );

void SetClk( void );
void mdelay( unsigned long msec );
void main( void );


/*----------------------------------------------------------------------
	O[oϐit@Cj
----------------------------------------------------------------------*/
/* At@xbh啶 */
static const unsigned char gCharcter_A[ 4 ] 		= { 0x04, 0x06, 0x0e, 0x02 };	// 'A'
static const unsigned char gCharcter_B[ 4 ] 		= { 0x00, 0x07, 0x0a, 0x06 };	// 'B'
static const unsigned char gCharcter_C[ 4 ] 		= { 0x00, 0x07, 0x08, 0x00 };	// 'C'
static const unsigned char gCharcter_D[ 4 ] 		= { 0x04, 0x07, 0x0e, 0x00 };	// 'D'
static const unsigned char gCharcter_E[ 4 ] 		= { 0x04, 0x07, 0x08, 0x02 };	// 'E'
static const unsigned char gCharcter_F[ 4 ] 		= { 0x04, 0x06, 0x08, 0x00 };	// 'F'
static const unsigned char gCharcter_G[ 4 ] 		= { 0x00, 0x07, 0x0a, 0x02 };	// 'G'
static const unsigned char gCharcter_H[ 4 ] 		= { 0x04, 0x06, 0x06, 0x02 };	// 'H'
static const unsigned char gCharcter_I[ 4 ] 		= { 0x01, 0x01, 0x08, 0x08 };	// 'I'
static const unsigned char gCharcter_J[ 4 ] 		= { 0x02, 0x01, 0x06, 0x00 };	// 'J'
static const unsigned char gCharcter_K[ 4 ] 		= { 0x04, 0x06, 0x00, 0x05 };	// 'K'
static const unsigned char gCharcter_L[ 4 ] 		= { 0x00, 0x07, 0x00, 0x00 };	// 'L'
static const unsigned char gCharcter_M[ 4 ] 		= { 0x08, 0x06, 0x06, 0x04 };	// 'M'
static const unsigned char gCharcter_N[ 4 ] 		= { 0x08, 0x06, 0x06, 0x01 };	// 'N'
static const unsigned char gCharcter_O[ 4 ] 		= { 0x00, 0x07, 0x0e, 0x00 };	// 'O'
static const unsigned char gCharcter_P[ 4 ] 		= { 0x04, 0x06, 0x0c, 0x02 };	// 'P'
static const unsigned char gCharcter_Q[ 4 ] 		= { 0x00, 0x07, 0x0e, 0x01 };	// 'Q'
static const unsigned char gCharcter_R[ 4 ] 		= { 0x04, 0x06, 0x0c, 0x03 };	// 'R'
static const unsigned char gCharcter_S[ 4 ] 		= { 0x08, 0x01, 0x0a, 0x02 };	// 'S'
static const unsigned char gCharcter_T[ 4 ] 		= { 0x01, 0x00, 0x08, 0x08 };	// 'T'
static const unsigned char gCharcter_U[ 4 ] 		= { 0x00, 0x07, 0x06, 0x00 };	// 'U'
static const unsigned char gCharcter_W[ 4 ] 		= { 0x02, 0x06, 0x06, 0x01 };	// 'W'
static const unsigned char gCharcter_X[ 4 ] 		= { 0x0a, 0x00, 0x00, 0x05 };	// 'X'
static const unsigned char gCharcter_Y[ 4 ] 		= { 0x09, 0x00, 0x00, 0x04 };	// 'Y'
static const unsigned char gCharcter_Z[ 4 ] 		= { 0x02, 0x01, 0x08, 0x04 };	// 'Z'

/*  */
static const unsigned char gCharcter_0[ 4 ] 		= { 0x07, 0x00, 0x00, 0x0e };	// '0'
static const unsigned char gCharcter_1[ 4 ] 		= { 0x00, 0x00, 0x00, 0x06 }; 	// '1'
static const unsigned char gCharcter_2[ 4 ] 		= { 0x03, 0x04, 0x02, 0x0c }; 	// '2'
static const unsigned char gCharcter_3[ 4 ] 		= { 0x01, 0x04, 0x02, 0x0e }; 	// '3'
static const unsigned char gCharcter_4[ 4 ] 		= { 0x04, 0x04, 0x02, 0x06 }; 	// '4'
static const unsigned char gCharcter_5[ 4 ] 		= { 0x05, 0x04, 0x02, 0x0a }; 	// '5'
static const unsigned char gCharcter_6[ 4 ] 		= { 0x07, 0x04, 0x02, 0x0a }; 	// '6'
static const unsigned char gCharcter_7[ 4 ] 		= { 0x00, 0x00, 0x00, 0x0e }; 	// '7'
static const unsigned char gCharcter_8[ 4 ] 		= { 0x07, 0x04, 0x02, 0x0e }; 	// '8'
static const unsigned char gCharcter_9[ 4 ] 		= { 0x05, 0x04, 0x02, 0x0e }; 	// '9'

/* L */
static const unsigned char gCharcter_Qestion[ 4 ]	= { 0x04, 0x01, 0x02, 0x0d };	// '?'
static const unsigned char gCharcter_Slash[ 4 ]		= { 0x00, 0x02, 0x04, 0x00 };	// '/'
static const unsigned char gCharcter_LeftParent[ 4 ]	= { 0x00, 0x00, 0x05, 0x00 };	// '['
static const unsigned char gCharcter_RightParent[ 4 ]	= { 0x00, 0x0a, 0x00, 0x00 };	// ']'
static const unsigned char gCharcter_Underbar[ 4 ]	= { 0x01, 0x00, 0x00, 0x00 };	// '_'
static const unsigned char gCharcter_Spase[ 4 ]		= { 0x00, 0x00, 0x00, 0x00 };	// ' '


/*----------------------------------------------------------------------
	\[XR[h
----------------------------------------------------------------------*/
/** LCD쓮ݒ
 * @param void
 * @retval void
 */
static void LcdInit( void )
{
	/* ZOgo͒[qݒ */
	LSE0 = 0xff;	/* LCD|[gIWX^0 */
	LSE1 = 0xff;	/* LCD|[gIWX^1 */
	LSE2 = 0xff;	/* LCD|[gIWX^2 */
	LSE3 = 0xff;	/* LCD|[gIWX^3 */
	LSE4 = 0xff;	/* LCD|[gIWX^4 */
	LSE5 = 0xff;	/* LCD|[gIWX^5 */
	LSE6 = 0xff;	/* LCD|[gIWX^6 */
	LSE7 = 0x1f;	/* LCD|[gIWX^7 */

	LCR3 = 0x40;	/* LCDNbN䃌WX^ */
	LCR2 = 0x08;	/* LCD\䃌WX^ */
	LCR1 = 0xc5;	/* LCDoCAX䃌WX^ */
	LCR0 = 0x23;	/* LCD䃌WX^ 1/4oCAX(COM0~3gp)*/
}

/** LCD\֐
 * @param num  : \ʒuԍ
 * @param data : \
 * @retval void
 */
static void LcdDispOne( unsigned char num , char data )
{
	unsigned short CurAddr;
	unsigned short NextAddr;
	unsigned short CurAddrBackup;
	unsigned short i;

	CurAddr = LcdGetCurAddr( num );		/* LCDf[^WX^AhX擾 */
	CurAddrBackup = CurAddr;		/* rɎgߑҔ */

	switch( data )
	{
		case 'A':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_A[ i ];		/* A */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'B':
			for( i = 0 ; i < 4 ; i++ ){

				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_B[ i ];		/* B */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'C':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_C[ i ];		/* C */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'D':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_D[ i ];		/* D */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'E':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_E[ i ];		/* E */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'F':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_F[ i ];		/* F */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'G':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_G[ i ];		/* G */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'H':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_H[ i ];		/* H */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'I':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_I[ i ];		/* I */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'J':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_J[ i ];		/* J */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'K':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_K[ i ];		/* K */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'L':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_L[ i ];		/* L */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'M':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_M[ i ];		/* M */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'N':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_N[ i ];		/* N */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'O':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_O[ i ];		/* O */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'P':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_P[ i ];		/* P */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'Q':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_Q[ i ];		/* Q */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'R':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_R[ i ];		/* R */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'S':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_S[ i ];		/* S */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'T':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_T[ i ];		/* T */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'U':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_U[ i ];		/* U */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'W':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_W[ i ];		/* W */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'X':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_X[ i ];		/* X */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'Y':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_Y[ i ];		/* Y */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case 'Z':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_Z[ i ];		/* Z */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '0':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_0[ i ];		/* 0 */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '1':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_1[ i ];		/* 1 */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '2':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_2[ i ];		/* 2 */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '3':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_3[ i ];		/* 3 */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '4':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_4[ i ];		/* 4 */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '5':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_5[ i ];		/* 5 */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '6':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_6[ i ];		/* 6 */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '7':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_7[ i ];		/* 7 */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '8':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_8[ i ];		/* 8 */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '9':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_9[ i ];		/* 9 */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '?':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_Qestion[ i ];	/* ? */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '/':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_Slash[ i ];	/* / */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '[':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_LeftParent[ i ];	/* [ */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case ']':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_RightParent[ i ];	/* ] */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case '_':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_Underbar[ i ];	/* _ */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		case ' ':
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_Spase[ i ];	/* Xy[X */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;

		default:
			for( i = 0 ; i < 4 ; i++ ){
				*( ( volatile unsigned char * ) CurAddr ) = gCharcter_Spase[ i ];	/* Xy[X */
				NextAddr = LcdGetNextAddr( CurAddr , CurAddrBackup );
				CurAddr = NextAddr;
			}
			break;
	}
}

/** LCD\֐
 * @param *data : \
 * @retval void
 */
static void LcdDispMulti( char *data )
{
	unsigned short	i;

	for( i = 0 ; i < CHAR_DATA_NUM ; i++ )		/* 14JԂ */
	{
		LcdDispOne( i , *data ); 		/* ʒuw \  */
		data++;
	}

	/* LCD䃌WX^ */
	LCR0 = LCR0 | 0x40;	/* LCD\rbg1Zbg:  */
	LCR0 = LCR0 | 0x80;	/* LCD쓮Jnrbg1Zbg: Jn */
}

/** LCDf[^WX^AhX擾֐
 * @param num  : \ʒuԍ
 * @retval void
 */
static unsigned short LcdGetCurAddr( unsigned char num )
{
	unsigned short pos;

	/* LCD̕\ʒu̐ݒ */
	switch( num )
	{
		case 0:
			pos = CHAR_POG_0;		/* LRA55L */
			break;
		case 1:
			pos = CHAR_POG_1;		/* LRA51L */
			break;
		case 2:
			pos = CHAR_POG_2;		/* LRA47L */
			break;
		case 3:
			pos = CHAR_POG_3;		/* LRA43L */
			break;
		case 4:
			pos = CHAR_POG_4;		/* LRA0L */
			break;
		case 5:
			pos = CHAR_POG_5;		/* LRA4L */
			break;
		case 6:
			pos = CHAR_POG_6;		/* LRA8L */
			break;
		case 7:
			pos = CHAR_POG_7;		/* LRA12L */
			break;
		case 8:
			pos = CHAR_POG_8;		/* LRA16L */
			break;
		case 9:
			pos = CHAR_POG_9;		/* LRA20L */
			break;
		case 10:
			pos = CHAR_POG_10;		/* LRA24L */
			break;
		case 11:
			pos = CHAR_POG_11;		/* LRA28L */
			break;
		case 12:
			pos = CHAR_POG_12;		/* LRA32L */
			break;
		case 13:
			pos = CHAR_POG_13;		/* LRA36L */
			break;
		default:
			pos = 0;
			break;
	}
	return ( pos ) ;
}

/** LCDf[^WX^AhX擾֐
 * @param CurAddr		 : \AhX
 * @param CurAddrBackup  : \AhX
  * @retval \AhX
 */
static unsigned short LcdGetNextAddr( unsigned short CurAddr, unsigned short CurAddrBackup )
{
	unsigned short NextAddr;

	NextAddr = CurAddr;

	if( ( CurAddrBackup == CHAR_POG_0 )||
		( CurAddrBackup == CHAR_POG_1 )||
		( CurAddrBackup == CHAR_POG_2 )||
		( CurAddrBackup == CHAR_POG_3 )||
		( CurAddrBackup == CHAR_POG_4 )||
 		( CurAddrBackup == CHAR_POG_5 )||
		( CurAddrBackup == CHAR_POG_6 )||
		( CurAddrBackup == CHAR_POG_7 ))
	{
		NextAddr--;	/* ڽ */
	}
	else
	{
		NextAddr++;	/* ڽ傫 */
	}
	return ( NextAddr );
}

/** NbNݒ
 * @param void
 * @retval void
 */
void SetClk( void )
{
	OCD = 0x04; /* I`bvIV[^NbNI */
	CM0 = 0x00;
	CM1 = 0x00;
	FRA0 = 0x01;
	FRA0 = 0x03;
	FRA2 = 0x00;
}

/** ~b҂
 * @param msec : ~b
 * @retval void
 */
void mdelay( unsigned long msec )
{
	volatile unsigned long i;

	for( i = 0; i<MILLI_SEC*msec; i++ )
	{
		;
	}
}


/** C֐
 * @param void
 * @retval void
 */
void main( void )
{
	/* ϐ錾 */
	char TextSpese[]	= "              ";

	char TextA[]		= "ABCDEFGHIJKLMN";
	char TextB[]		= "BCDEFGHIJKLMNO";
	char TextC[]		= "CDEFGHIJKLMNOP";
	char TextD[]		= "DEFGHIJKLMNOPR";
	char TextE[]		= "EFGHIJKLMNOPRS";
	char TextF[]		= "FGHIJKLMNOPRST";
	char TextG[]		= "GHIJKLMNOPRSTU";
	char TextH[]		= "HIJKLMNOPRSTUW";
	char TextI[]		= "IJKLMNOPRSTUWX";
	char TextJ[]		= "JKLMNOPRSTUWXY";
	char TextK[]		= "KLMNOPRSTUWXYZ";

	PRCR = 0x0f;			/* veNgWX^ */
	SetClk();			/* NbNZbg֐ */

	LcdInit();			/* LCD쓮ݒ֐ */
	LcdDispMulti( TextSpese );	/* LCD\NA */

	PD10 = 0xC0;
	PD11 = 0xC0;
	P10 = 0;
	P11 = 0;

	PD13 = ~0xF0;

	while( 1 )
	{
		if( ( P13 & 0x10 ) == 0 )	P10 |= 0x80;
		if( ( P13 & 0x20 ) == 0 )	P10 |= 0x40;
		if( ( P13 & 0x40 ) == 0 )	P11 |= 0x80;
		if( ( P13 & 0x80 ) == 0 )	P11 |= 0x40;

		LcdDispMulti( TextA );
		mdelay( 500 );

		LcdDispMulti( TextC );
		mdelay( 500 );

		LcdDispMulti( TextD );
		mdelay( 500 );

		LcdDispMulti( TextE );
		mdelay( 500 );

		LcdDispMulti( TextF );
		mdelay( 500 );

		LcdDispMulti( TextG );
		mdelay( 500 );

		LcdDispMulti( TextH );
		mdelay( 500 );

		LcdDispMulti( TextI );
		mdelay( 500 );

		LcdDispMulti( TextJ );
		mdelay( 500 );

		LcdDispMulti( TextK );
		mdelay( 500 );
	}
}

/* End of File */
